import com.excelsior.xFunction.*;


public class sample12{

    public static final int IDC_ARROW = 32512;


    public static void main(String[] str) throws xFunctionException{

        String ClassName = "ClassName";
        String WindowName = "WindowName";

        WNDCLASS wc = new WNDCLASS();
        WNDPROC MainWinProc = new WNDPROC();


        wc.style = 0x1000 + 0x0020;
        wc.lpfnWndProc = MainWinProc;
        wc.cbClsExtra = 0;
        wc.cbWndExtra = 0;
        wc.hIcon = 0;
        wc.lpszMenuName = null;
        wc.lpszClassName = ClassName;


        try{
            xFunction f=new xFunction("kernel32","int GetModuleHandleA(int)");
            wc.hInstance = ((Integer)f.invoke(new Argument(0))).intValue();
        }catch(Exception e){
            System.out.println("some Exception in GetModuleHandle");
        }


        try{
            xFunction f=new xFunction("user32","int LoadCursorA(int,int)");
            wc.hCursor = ((Integer)f.invoke(new Argument(0), new Argument(IDC_ARROW) )).intValue();
        }catch(Exception e){
            System.out.println("some Exception in LoadCursor");
        }


        try{
            xFunction f=new xFunction("gdi32","int CreateSolidBrush(int)");
            wc.hbrBackground = ((Integer)f.invoke(new Argument(0))).intValue();
        }catch(Exception e){
            System.out.println("some Exception in CreateSolidBrush");
        }



        try{
            xFunction f=new xFunction("user32","short RegisterClassA(WNDCLASS*)");
            if( ((Short)f.invoke(Pointer.createPointerTo(wc))).shortValue() == 0 ){
                System.out.println("Error");
                throw new Error();
            }
        }catch(Exception e){
            System.out.println("!some Exception in RegisterClass");
        }



        try{
            Argument[] args = new Argument[12];

            xFunction f=new xFunction("user32","int CreateWindowExA(int,CSTRING,CSTRING,int,int,int,int,int,int,int,int,int)");
            args[0] = new Argument(0);
            args[1] = new Argument(ClassName, Argument.CSTRING);
            args[2] = new Argument(WindowName, Argument.CSTRING);
            args[3] = new Argument(0x10000000+ //WS_VISIBLE
                                   0xC00000|   //WS_CAPTION
                                   0x80000|    //WS_SYSMENU
                                   0x40000|    //WS_THICKFRAME
                                   0x20000|    //WS_MINIMIZEBOX
                                   0x10000);   //WS_MAXIMIZEBOX
            args[4] = new Argument(10);
            args[5] = new Argument(10);
            args[6] = new Argument(400);
            args[7] = new Argument(400);

            args[8] = new Argument(0);
            args[9] = new Argument(0);
            args[10]= new Argument(wc.hInstance);
            args[11]= new Argument(0);

            int res=((Integer)f.invoke(args)).intValue();
                                   
            if(res== 0 ){
                System.out.println("CreateWindow Error");
                throw new Error();
            }
        }catch(Exception e){
            System.out.println("!some Exception in CreateWindow");
        }

        xFunction GetMessage = new xFunction("user32", "int GetMessageA(MSG*,int,int,int)");
        xFunction TranslateMessage = new xFunction("user32", "int TranslateMessage(MSG*)");
        xFunction DispatchMessage = new xFunction("user32", "int DispatchMessageA(MSG*)");


        MSG msg = new MSG();

        Pointer pmsg = Pointer.createPointerTo(msg);

        while( ((Integer)GetMessage.invoke(pmsg,
                                           new Argument(0),
                                           new Argument(0),
                                           new Argument(0))).intValue() != 0){
            TranslateMessage.invoke(pmsg);
            DispatchMessage.invoke(pmsg);
        }

        System.out.println("OK");
    }
}




class MSG extends Structure{

    int     hwnd;
    int     message;
    int     wParam;
    int     lParam;
    int     time;
    int     pt_x;
    int     pt_y;

    public String defineLayout(){
        return "int hwnd, int message, int wParam, int lParam, int time, "+
               "int pt_x, int pt_y";
    }

    public MSG(){}
}





class WNDPROC extends Callback{

    public String defineSignature(){
	return "int foo(int,int,int,int)";
    }


    void Beep1() throws xFunctionException{
	xFunction b=new xFunction("kernel32","int Beep(int,int)");
	b.invoke(new Argument(1770),new Argument(100));
    }	


    void Beep2() throws xFunctionException{
	xFunction b=new xFunction("kernel32","int Beep(int,int)");
	b.invoke(new Argument(500),new Argument(100));
    }	


    void PostQuitMessage(int nExitCode) throws xFunctionException{
        xFunction f=new xFunction("user32", "void PostQuitMessage(int)");
        f.invoke(new Argument(nExitCode));
    }


    int foo(int hwnd, int msg, int wParam, int lParam) throws xFunctionException{

        int result=0;

        switch(msg){
          case 0x0201: //WM_LBUTTONDOWN
            Beep1();
            break;
          case 0x0204: //WM_RBUTTONDOWN
            Beep2();
            break;
          case 0x0010: //WM_CLOSE
            PostQuitMessage(0);
            break;
        }


        try{
            xFunction f=new xFunction("user32","int DefWindowProcA(int,int,int,int)");
            result = ((Integer)f.invoke(new Argument(hwnd),
                                        new Argument(msg),
                                        new Argument(wParam),
                                        new Argument(lParam))).intValue();
        }catch(Exception e){
            System.out.println("Exception");
        }

        return result;
    }
}






class WNDCLASS extends Structure{

    public int style;
           WNDPROC lpfnWndProc;
           int cbClsExtra;
           int cbWndExtra;

           int hInstance;
           int hIcon;
           int hCursor;
           int hbrBackground;
           String lpszMenuName;
           String lpszClassName;


    public String defineLayout(){
        return "int style, WNDPROC lpfnWndProc, int cbClsExtra,"+
               "int cbClsExtra, int hInstance, int hIcon,"+
               "int hCursor, int hbrBackground, CSTRING lpszMenuName,"+
               "CSTRING lpszClassName";
    }

    public WNDCLASS(){};
}








